Report packages kept back by origins

Bug #1821376 reported by Balint Reczey on 2019-03-22
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
unattended-upgrades (Ubuntu)
Undecided
Unassigned
Xenial
Undecided
Unassigned
Bionic
Undecided
Unassigned
Disco
Undecided
Unassigned

Bug Description

[Impact]

* Packages kept back are listed in the email report, but it is not clear from which origins they are installable. This information may help administrators to decide if the packages need to be manually upgraded.

[Test Case]

* test_mail.py test is updated to check if the kept back packages are reported per origin and this is checked at build time.

* For manual testing:
  1. Configure u-u to allow upgrades from the -updates pocket and send email with the upgrade report.
  2. Set up the system to have a few packages upgradable from both the -security and -updates pockets.
  3. Mark a subset of packages which are upgradable as held, marking packages from each of the pockets.
  4. Run u-u and observe the kept packages listed in the email. Each package is listed only in the allowed origin providing the highest version. (LP: #1848697 covers listing them in all origins from which the packages could be upgraded to.)

[Regression Potential]

* Unattended upgrades may crash while trying to perform updates or while trying to send the summary email. Build-time tests and autopkgtests include testing both functions.

Balint Reczey (rbalint) on 2019-03-22
description: updated
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package unattended-upgrades - 1.12

---------------
unattended-upgrades (1.12) experimental; urgency=medium

  [ Brannon Dorsey ]
  * Remove double "format" in 50unattended-upgrades configuration files

  [ Daniel Herzig ]
  * man: improve unattended-upgrade.8 man-page (Closes: #905289)

  [ Jonatan Nyberg ]
  * Swedish debconf strings update (Closes: #925488)

  [ Balint Reczey ]
  * Compare apt.package.Version objects and not the versions' string
    representation. This prevented adjusting candidates when the strings sorted
    differently (LP: #1820888)
  * Enable test_clean and test_patch_days tests
  * Fall back to adjusting more packages' candidates when a package from an
    allowed origin can't be marked to install/upgrade. (LP: #1821101)
  * Skip sending email when no package had to be installed, upgraded or removed
    (LP: #1821103) (Closes: #924554)
  * Add a few debug logging points
  * Report packages kept back by origin (LP: #1821376)
  * Fix trailing newlines in wrapped email lines
  * Describe candidate adjustment fallback better in the debug message
  * Fix missing space. Thanks to Alban VIDAL
  * Update POT file
  * Test upgrades to -updates and to -proposed in upgrade-all-security
    autopkgtest. Also enable -updates, too, while testing in Debian.
  * Add ${distro_id}ESM:${distro_codename}-security to allowed origins
    (LP: #1823376)
  * Detect changes to moved conffiles (LP: #1823872)
  * Add tests for checking conffile moves.
    Build depend on and use equivs to generate new test packages
  * Make sure autoremovals don't start with a dirty cache and remove other
    packages (LP: #1824341)
  * Stop raising NoAllowedOriginError when marking packages to upgrade/install
    fails (LP: #1824876)
  * Continue applying minimal sets when one set can't be marked for upgrade.
    Thanks to Anderson Luiz Alves for the patch, it needed minor modifications
    (LP: #1824341)
  * Skip trying to upgrade held packages in call_adjusted() (LP: #1824804)
  * Adjust only transitive dependencies in the fallback when a package from an
    allowed origin can't be marked to install/upgrade.
    This is a much lighter approach than marking every upgradable package
    because the full fallback was triggered on packages held back as well,
    using an excessive amount of CPU time. (LP: #1824804, #1824949)
  * Follow all kinds of transitive dependencies when adjusting dependencies
  * Split() conffile data to set of names only once
  * Don't parse dpkg conffile db when there are no conffiles in the package
  * Detect unchanged moved conffiles.
    When a package moves a conffile properly without any change no conffile
    prompt needs to be shown thus the package can be upgraded unattended even
    when the conffile is changed locally. (LP: #1823872)

 -- Balint Reczey <email address hidden> Thu, 18 Apr 2019 16:38:31 +0200

Changed in unattended-upgrades (Ubuntu):
status: New → Fix Released
Balint Reczey (rbalint) on 2019-10-18
description: updated

Hello Balint, or anyone else affected,

Accepted unattended-upgrades into disco-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/unattended-upgrades/1.10ubuntu5.2 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-disco to verification-done-disco. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-disco. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in unattended-upgrades (Ubuntu Disco):
status: New → Fix Committed
tags: added: verification-needed verification-needed-disco
Brian Murray (brian-murray) wrote :

Hello Balint, or anyone else affected,

Accepted unattended-upgrades into bionic-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/unattended-upgrades/1.1ubuntu1.18.04.12 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-bionic to verification-done-bionic. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-bionic. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in unattended-upgrades (Ubuntu Bionic):
status: New → Fix Committed
tags: added: verification-needed-bionic
Changed in unattended-upgrades (Ubuntu Xenial):
status: New → Fix Committed
tags: added: verification-needed-xenial
Brian Murray (brian-murray) wrote :

Hello Balint, or anyone else affected,

Accepted unattended-upgrades into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/unattended-upgrades/1.1ubuntu1.18.04.7~16.04.4 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-xenial to verification-done-xenial. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-xenial. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Balint Reczey (rbalint) wrote :

Tested 1.10ubuntu5.2 on Disco:

root@uu-sru-dd:~# apt list --upgradable
Listing... Done
apport/disco-updates,disco-security 2.20.10-0ubuntu27.2 all [upgradable from: 2.20.10-0ubuntu27.1]
snapd/disco-updates 2.40+19.04 amd64 [upgradable from: 2.38+19.04]
root@uu-sru-dd:~# perl -MMIME::QuotedPrint -pe '$_=MIME::QuotedPrint::decode($_);' /var/mail/mail
From <email address hidden> Fri Nov 01 17:48:11 2019
Return-path: <email address hidden>
Envelope-to: <email address hidden>
Delivery-date: Fri, 01 Nov 2019 17:48:11 +0000
Received: from root by uu-sru-dd.lxd with local (Exim 4.92)
 (envelope-from <email address hidden>)
 id 1iQb1v-0001Pj-9M
 for <email address hidden>; Fri, 01 Nov 2019 17:48:11 +0000
Subject: [package on hold] unattended-upgrades result for uu-sru-dd.lxd: SUCCESS
To: <email address hidden>
Auto-Submitted: auto-generated
MIME-Version: 1.0
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
From: root <email address hidden>
Message-Id: <email address hidden>
Date: Fri, 01 Nov 2019 17:48:11 +0000

Unattended upgrade result: All upgrades installed

Packages with upgradable origin but kept back:
 Ubuntu disco-updates:
  snapd apport

Unattended-upgrades log:
Initial blacklist :
Initial whitelist:
Starting unattended upgrades script
Allowed origins are: o=Ubuntu,a=disco, o=Ubuntu,a=disco-security, o=UbuntuESM,a=disco, o=Ubuntu,a=disco-updates
Packages that will be upgraded:

root@uu-sru-dd:~# dpkg -l unattended-upgrades | cat
Desired=Unknown/Install/Remove/Purge/Hold
| Status=Not/Inst/Conf-files/Unpacked/halF-conf/Half-inst/trig-aWait/Trig-pend
|/ Err?=(none)/Reinst-required (Status,Err: uppercase=bad)
||/ Name Version Architecture Description
+++-===================-=============-============-===========================================
ii unattended-upgrades 1.10ubuntu5.2 all automatic installation of security upgrades

description: updated
Balint Reczey (rbalint) wrote :

root@uu-sru-x:~# apt list --upgradable
Listing... Done
apport/xenial-updates,xenial-security 2.20.1-0ubuntu2.20 all [upgradable from: 2.20.1-0ubuntu2.19]
snapd/xenial-updates 2.40 amd64 [upgradable from: 2.37.4ubuntu0.1]
root@uu-sru-x:~# perl -MMIME::QuotedPrint -pe '$_=MIME::QuotedPrint::decode($_);' /var/mail/mail
From <email address hidden> Fri Nov 01 17:48:17 2019
Return-path: <email address hidden>
Envelope-to: <email address hidden>
Delivery-date: Fri, 01 Nov 2019 17:48:17 +0000
Received: from root by uu-sru-x.lxd with local (Exim 4.86_2)
 (envelope-from <email address hidden>)
 id 1iQb21-0001Jg-4W
 for <email address hidden>; Fri, 01 Nov 2019 17:48:17 +0000
Subject: [package on hold] unattended-upgrades result for uu-sru-x: True
To: <email address hidden>
Auto-Submitted: auto-generated
MIME-Version: 1.0
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
From: root <email address hidden>
Message-Id: <email address hidden>
Date: Fri, 01 Nov 2019 17:48:17 +0000

Unattended upgrade returned: True

Packages that were upgraded:

Packages with upgradable origin but kept back:
 Ubuntu xenial-updates:
  snapd apport

Unattended-upgrades log:
Initial blacklisted packages:
Initial whitelisted packages:
Starting unattended upgrades script
Allowed origins are: o=Ubuntu,a=xenial, o=Ubuntu,a=xenial-security, o=UbuntuESM,a=xenial, o=Ubuntu,a=xenial-updates
Packages that will be upgraded:

root@uu-sru-x:~# dpkg -l unattended-upgrades | cat
Desired=Unknown/Install/Remove/Purge/Hold
| Status=Not/Inst/Conf-files/Unpacked/halF-conf/Half-inst/trig-aWait/Trig-pend
|/ Err?=(none)/Reinst-required (Status,Err: uppercase=bad)
||/ Name Version Architecture Description
+++-===================-==========================-============-===========================================
ii unattended-upgrades 1.1ubuntu1.18.04.7~16.04.4 all automatic installation of security upgrades

Balint Reczey (rbalint) wrote :

root@uu-sru-bb:~# apt list --upgradable
Listing... Done
apport/bionic-updates,bionic-security 2.20.9-0ubuntu7.8 all [upgradable from: 2.20.9-0ubuntu7.7]
snapd/bionic-updates 2.40+18.04 amd64 [upgradable from: 2.37.4+18.04.1]
root@uu-sru-bb:~# perl -MMIME::QuotedPrint -pe '$_=MIME::QuotedPrint::decode($_);' /var/mail/mail
From <email address hidden> Fri Nov 01 17:48:17 2019
Return-path: <email address hidden>
Envelope-to: <email address hidden>
Delivery-date: Fri, 01 Nov 2019 17:48:17 +0000
Received: from root by uu-sru-bb.lxd with local (Exim 4.90_1)
 (envelope-from <email address hidden>)
 id 1iQb21-00014X-Mj
 for <email address hidden>; Fri, 01 Nov 2019 17:48:17 +0000
Subject: [package on hold] unattended-upgrades result for uu-sru-bb: True
To: <email address hidden>
Auto-Submitted: auto-generated
MIME-Version: 1.0
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
From: root <email address hidden>
Message-Id: <email address hidden>
Date: Fri, 01 Nov 2019 17:48:17 +0000

Unattended upgrade returned: True

Packages that were upgraded:

Packages with upgradable origin but kept back:
 Ubuntu bionic-updates:
  snapd apport

Unattended-upgrades log:
Initial blacklisted packages:
Initial whitelisted packages:
Starting unattended upgrades script
Allowed origins are: o=Ubuntu,a=bionic, o=Ubuntu,a=bionic-security, o=UbuntuESM,a=bionic, o=Ubuntu,a=bionic-updates
Packages that will be upgraded:

tags: added: verification-done verification-done-bionic verification-done-disco verification-done-xenial
removed: verification-needed verification-needed-bionic verification-needed-disco verification-needed-xenial
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package unattended-upgrades - 1.10ubuntu5.2

---------------
unattended-upgrades (1.10ubuntu5.2) disco; urgency=medium

  * Report packages kept back by origin (LP: #1821376)
  * Store list of kept packages and report the number of them in motd
    (LP: #1823070)
  * Default to "/" as rootdir to fix saving list of kept packages.
    Thanks to Paul Wise (Closes: #932160) (LP: #1823070)
  * debian/tests/control: Mark upgrade-between-snapshots as flaky
    (Closes: #941752) (LP: #1848354)

 -- Balint Reczey <email address hidden> Fri, 18 Oct 2019 13:22:02 +0200

Changed in unattended-upgrades (Ubuntu Disco):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for unattended-upgrades has completed successfully and the package is now being released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package unattended-upgrades - 1.1ubuntu1.18.04.12

---------------
unattended-upgrades (1.1ubuntu1.18.04.12) bionic; urgency=medium

  * Report packages kept back by origin (LP: #1821376)
  * Store list of kept packages and report the number of them in motd
    (LP: #1823070)
  * Default to "/" as rootdir to fix saving list of kept packages.
    Thanks to Paul Wise (Closes: #932160)
  * debian/tests/control: Mark upgrade-between-snapshots as flaky
    (Closes: #941752) (LP: #1848354)

 -- Balint Reczey <email address hidden> Fri, 18 Oct 2019 13:24:28 +0200

Changed in unattended-upgrades (Ubuntu Bionic):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package unattended-upgrades - 1.1ubuntu1.18.04.7~16.04.4

---------------
unattended-upgrades (1.1ubuntu1.18.04.7~16.04.4) xenial; urgency=medium

  * Report packages kept back by origin (LP: #1821376)
  * Store list of kept packages and report the number of them in motd
    (LP: #1823070)
  * Default to "/" as rootdir to fix saving list of kept packages.
    Thanks to Paul Wise (Closes: #932160)
  * debian/tests/control: Mark upgrade-between-snapshots as flaky
    (Closes: #941752) (LP: #1848354)

 -- Balint Reczey <email address hidden> Fri, 18 Oct 2019 13:29:41 +0200

Changed in unattended-upgrades (Ubuntu Xenial):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers